# SPDX-FileCopyrightText: Copyright (c) 2025 Cisco and/or its affiliates.
# SPDX-License-Identifier: Apache-2.0
# coding: utf-8

"""
    Agent Connect Protocol

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 0.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from agntcy_acp.acp_v0.models.run_error import RunError
from agntcy_acp.acp_v0.models.run_interrupt import RunInterrupt
from agntcy_acp.acp_v0.models.run_result import RunResult
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

RUNOUTPUT_ONE_OF_SCHEMAS = ["RunError", "RunInterrupt", "RunResult"]

class RunOutput(BaseModel):
    """
    Output of a Run. Can be the final result or an interrupt.
    """
    # data type: RunResult
    oneof_schema_1_validator: Optional[RunResult] = None
    # data type: RunInterrupt
    oneof_schema_2_validator: Optional[RunInterrupt] = None
    # data type: RunError
    oneof_schema_3_validator: Optional[RunError] = None
    actual_instance: Optional[Union[RunError, RunInterrupt, RunResult]] = None
    one_of_schemas: Set[str] = { "RunError", "RunInterrupt", "RunResult" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    discriminator_value_class_map: Dict[str, str] = {
    }

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = RunOutput.model_construct()
        error_messages = []
        match = 0
        # validate data type: RunResult
        if not isinstance(v, RunResult):
            error_messages.append(f"Error! Input type `{type(v)}` is not `RunResult`")
        else:
            match += 1
        # validate data type: RunInterrupt
        if not isinstance(v, RunInterrupt):
            error_messages.append(f"Error! Input type `{type(v)}` is not `RunInterrupt`")
        else:
            match += 1
        # validate data type: RunError
        if not isinstance(v, RunError):
            error_messages.append(f"Error! Input type `{type(v)}` is not `RunError`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in RunOutput with oneOf schemas: RunError, RunInterrupt, RunResult. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in RunOutput with oneOf schemas: RunError, RunInterrupt, RunResult. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into RunResult
        try:
            instance.actual_instance = RunResult.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into RunInterrupt
        try:
            instance.actual_instance = RunInterrupt.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into RunError
        try:
            instance.actual_instance = RunError.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into RunOutput with oneOf schemas: RunError, RunInterrupt, RunResult. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into RunOutput with oneOf schemas: RunError, RunInterrupt, RunResult. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], RunError, RunInterrupt, RunResult]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


